# Layers

```@meta
CurrentModule = Lux
```

## Index

```@index
Pages = ["layers.md"]
```

## Containers

```@docs
BranchLayer
Chain
PairwiseFusion
Parallel
SkipConnection
```

## Convolutional Layers

```@docs
Conv
ConvTranspose
CrossCor
```

## Dropout Layers

```@docs
AlphaDropout
Dropout
VariationalHiddenDropout
```

## Pooling Layers

```@docs
AdaptiveMaxPool
AdaptiveMeanPool
GlobalMaxPool
GlobalMeanPool
MaxPool
MeanPool
```

## Recurrent Layers

```@docs
GRUCell
LSTMCell
RNNCell
Recurrence
StatefulRecurrentCell
```

## Linear Layers

```@docs
Bilinear
Dense
Embedding
Scale
```

## Misc. Helper Layers

```@docs
ActivationFunction
FlattenLayer
Maxout
NoOpLayer
ReshapeLayer
SelectDim
WrappedFunction
```

## Normalization Layers

```@docs
BatchNorm
GroupNorm
InstanceNorm
LayerNorm
WeightNorm
```

## Upsampling

```@docs
PixelShuffle
Upsample
```
